searchNodes=[{"doc":"Community theatre is similar but opposite to the broadway package. It&#39;s designed to handle ingesting data from sources at various update frequencies and emit them again to consumers at a constrained rate. Particularly useful for devices of constrained resources. Usage Any Erlang term can be published to arbitrary topics at any rate: for bottle_count &lt;- Enum.reverse(0..99) do CommunityTheatre.publish(:bottles_of_beer_on_the_wall, bottle_count) Process.sleep(100) end However subscribers will only receive updates at the frequency they specify. You can implement the CommunityTheatre.RateLimiter behaviour to specify how to deal with extra methods. This package includes the Drop and Average limiters. Drop is used by default if none is specified. iex&gt; CommunityTheatre.subscribe(:bottles_of_beer_on_the_wall, 0.3, CommunityTheatre.RateLimiter.Average) ...&gt; for bottle_count &lt;- Enum.reverse(0..99) do ...&gt; CommunityTheatre.publish(:bottles_of_beer_on_the_wall, bottle_count) ...&gt; Process.sleep(100) ...&gt; end ...&gt; flush {CommunityTheatre, %CommunityTheatre.Message{ payload: 83, received_at: ~U[2020-04-10 04:31:58.215609Z], topic: :bottles_of_beer_on_the_wall }} {CommunityTheatre, %CommunityTheatre.Message{ payload: 50, received_at: ~U[2020-04-10 04:32:01.548600Z], topic: :bottles_of_beer_on_the_wall }} {CommunityTheatre, %CommunityTheatre.Message{ payload: 17, received_at: ~U[2020-04-10 04:32:04.881524Z], topic: :bottles_of_beer_on_the_wall }}","ref":"CommunityTheatre.html","title":"CommunityTheatre","type":"module"},{"doc":"Publish a message to subscribed clients.","ref":"CommunityTheatre.html#publish/1","title":"CommunityTheatre.publish/1","type":"function"},{"doc":"Publishes the provided payload to the topic. Wraps the topic and payload in a Message.t() and calls publish/1.","ref":"CommunityTheatre.html#publish/2","title":"CommunityTheatre.publish/2","type":"function"},{"doc":"Subscribe to updates from the given topic. Calling this function subscribes the calling process to updates to the current topic. If updates are received faster than the specified frequency then they are dropped. Params: topic an artibrary name for a stream of data being proccessed in the system. update_frequency (in Hz) how often you would like to receive updates.","ref":"CommunityTheatre.html#subscribe/2","title":"CommunityTheatre.subscribe/2","type":"function"},{"doc":"Subscribe to updates from the given topic. Calling this function subscribes the calling process to updates to the current topic. Params: topic an artibrary name for a stream of data being proccessed in the system. update_frequency (in Hz) how often you would like to receive updates. rate_limiter the name of a module which implements the CommunityTheatre.RateLimiter behaviour, which specifies what to do when data arrives faster than you are requesting.","ref":"CommunityTheatre.html#subscribe/3","title":"CommunityTheatre.subscribe/3","type":"function"},{"doc":"This module coordinates client subscriptions and their rate limiters to ensure that clients only receive updates at the rate they specified.","ref":"CommunityTheatre.ActiveSubscription.html","title":"CommunityTheatre.ActiveSubscription","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"CommunityTheatre.ActiveSubscription.html#child_spec/1","title":"CommunityTheatre.ActiveSubscription.child_spec/1","type":"function"},{"doc":"Start an instance of an active subscription with the provided options.","ref":"CommunityTheatre.ActiveSubscription.html#start_link/1","title":"CommunityTheatre.ActiveSubscription.start_link/1","type":"function"},{"doc":"","ref":"CommunityTheatre.ActiveSubscription.html#t:hz/0","title":"CommunityTheatre.ActiveSubscription.hz/0","type":"type"},{"doc":"","ref":"CommunityTheatre.ActiveSubscription.html#t:option/0","title":"CommunityTheatre.ActiveSubscription.option/0","type":"type"},{"doc":"","ref":"CommunityTheatre.ActiveSubscription.html#t:options/0","title":"CommunityTheatre.ActiveSubscription.options/0","type":"type"},{"doc":"","ref":"CommunityTheatre.ActiveSubscription.html#t:rate_limiter/0","title":"CommunityTheatre.ActiveSubscription.rate_limiter/0","type":"type"},{"doc":"","ref":"CommunityTheatre.ActiveSubscription.html#t:update_frequency/0","title":"CommunityTheatre.ActiveSubscription.update_frequency/0","type":"type"},{"doc":"A struct containing an inbound message and it&#39;s metadata.","ref":"CommunityTheatre.Message.html","title":"CommunityTheatre.Message","type":"module"},{"doc":"","ref":"CommunityTheatre.Message.html#init/2","title":"CommunityTheatre.Message.init/2","type":"function"},{"doc":"Create a new message struct given a topic, payload and received_at time.","ref":"CommunityTheatre.Message.html#init/3","title":"CommunityTheatre.Message.init/3","type":"function"},{"doc":"","ref":"CommunityTheatre.Message.html#t:t/0","title":"CommunityTheatre.Message.t/0","type":"type"},{"doc":"The RateLimiter behaviour allows you to define for yourself how you would like messages to be handled in the event that they arrive faster than required. The behaviour specifies three callbacks; init/1 which you can use for initialising your data structure, merge/2 which you can use to update your data when new messages are received, and get/1 which is called when it is time to send a message to a subscribee. CommunityTheatre provides two rate limiters out of the box; but you can easily write your own if they don&#39;t meet your needs: CommunityTheatre.RateLimiter.Drop - drop any spurious messages and only pass on the last message received. CommunityTheatre.RateLimiter.Average - computes a rolling average presuming that the inbound message payloads are numeric.","ref":"CommunityTheatre.RateLimiter.html","title":"CommunityTheatre.RateLimiter","type":"behaviour"},{"doc":"Returns the next value that should be sent to a subscriber.","ref":"CommunityTheatre.RateLimiter.html#c:get/1","title":"CommunityTheatre.RateLimiter.get/1","type":"callback"},{"doc":"Called when creating a new rate limited subscription. Use this to initialise the data structure needed to keep state for rate limiting.","ref":"CommunityTheatre.RateLimiter.html#c:init/1","title":"CommunityTheatre.RateLimiter.init/1","type":"callback"},{"doc":"Called when a new message is received from a source so that you can update the limiter state.","ref":"CommunityTheatre.RateLimiter.html#c:merge/2","title":"CommunityTheatre.RateLimiter.merge/2","type":"callback"},{"doc":"","ref":"CommunityTheatre.RateLimiter.html#t:hz/0","title":"CommunityTheatre.RateLimiter.hz/0","type":"type"},{"doc":"","ref":"CommunityTheatre.RateLimiter.html#t:t/0","title":"CommunityTheatre.RateLimiter.t/0","type":"type"},{"doc":"Sample averaging rate limiter This module implements the CommunityTheatre.RateLimiter behaviour in such a way as to compute a rolling average of any unsent payloads. This obviously only works if the payload value is a number.","ref":"CommunityTheatre.RateLimiter.Average.html","title":"CommunityTheatre.RateLimiter.Average","type":"module"},{"doc":"Sample dropping ratae limiter Only keeps the last message it receives for passing on to the subscriber.","ref":"CommunityTheatre.RateLimiter.Drop.html","title":"CommunityTheatre.RateLimiter.Drop","type":"module"}]